﻿using C1.Win.C1Document;
using C1.Win.C1Document.Export;
using C1.Win.FlexReport;
using System;
using System.Collections.Generic;
using System.Drawing.Printing;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web.Mvc;

namespace C1ReportAsAPI.Controllers
{
    public class TestController : ApiController
    {
        private C1FlexReport c1Report;
        
        [System.Web.Http.HttpGet]
        [System.Web.Http.Route("api/getpdf")]
        public IHttpActionResult ExportPdf()
        
        {
            c1Report = new C1FlexReport();
            var path = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"Files\Documenti.flxr");
            c1Report.Load(path, "ConsegnaDPI");
            c1Report.Render();
            var stream = new MemoryStream();

            //c1Report.RenderToFilter(stream);
            var toPdfFileName = "";
            PdfFilter filter = new PdfFilter()
            {
                Stream = new MemoryStream(),
                DocumentInfo = new DocumentInfo
                {
                    Author = "Grapecity",
                    CreationTime = DateTime.Now,
                    RevisionTime = DateTime.Now,
                    Creator = "Grapecity",
                    Title = ""
                },
                PageSettings = new C1PageSettings
                {
                    Landscape = false,
                    PaperSize = PaperKind.A4
                },
                FileName = toPdfFileName,
                PdfACompatible = true,
                Preview = false
            };
            c1Report.RenderToFilter(filter);

            filter.Stream.Position = 0;
            return new eBookResult(filter.Stream,Request, "Documenti_ConsegnaDPI.pdf");
        }
    }
    public class eBookResult : IHttpActionResult
    {
        MemoryStream bookStuff;
        string PdfFileName;
        HttpRequestMessage httpRequestMessage;
        HttpResponseMessage httpResponseMessage;
        public eBookResult(Stream data, HttpRequestMessage request, string filename)
        {
            bookStuff = (MemoryStream)data;
            httpRequestMessage = request;
            PdfFileName = filename;
        }
        public System.Threading.Tasks.Task<HttpResponseMessage> ExecuteAsync(System.Threading.CancellationToken cancellationToken)
        {
            httpResponseMessage = httpRequestMessage.CreateResponse(HttpStatusCode.OK);
            httpResponseMessage.Content = new StreamContent(bookStuff);
            //httpResponseMessage.Content = new ByteArrayContent(bookStuff.ToArray());  
            httpResponseMessage.Content.Headers.ContentDisposition = new System.Net.Http.Headers.ContentDispositionHeaderValue("attachment");
            httpResponseMessage.Content.Headers.ContentDisposition.FileName = PdfFileName;
            httpResponseMessage.Content.Headers.ContentType = new System.Net.Http.Headers.MediaTypeHeaderValue("application/octet-stream");

            return System.Threading.Tasks.Task.FromResult(httpResponseMessage);
        }
    }
}
